diff --git a/game/client/build.gradle.kts b/game/client/build.gradle.kts
index faee365fa..1c6b481df 100644
--- a/game/client/build.gradle.kts
+++ b/game/client/build.gradle.kts
@@ -61,6 +61,7 @@ dependencies {
     implementation(platform(libs.lwjgl.bom))
 
     implementation("com.github.JnCrMx:discord-game-sdk4j:v0.5.5")?.let { include(it) }
+    implementation("com.github.electronstudio:sdl2gdx:1.0.5")?.let { include(it) }
 
     implementation("objects:client:43db9b498cb67058d2e12d394e6507722e71bb45") // Minecraft client jar
 }
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index ea097fbfa..4432309dd 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -10,6 +10,7 @@ import java.io.File;
 import java.io.IOException;
 import java.net.HttpURLConnection;
 import java.net.URL;
+import java.nio.file.Files;
 import java.util.*;
 
 import com.mojang.logging.LogUtils;
@@ -325,6 +326,24 @@ public class Minecraft
         INSTANCE = this;
     }
 
+    public static boolean isClientASteamDeck() {
+        final File vendor = new File("/sys/devices/virtual/dmi/id/board_vendor");
+        final File name = new File("/sys/devices/virtual/dmi/id/board_name");
+        if (vendor.exists() && vendor.isFile() && name.exists() && name.isFile()) {
+            try {
+                final List<String> vendorText = Files.readAllLines(vendor.toPath());
+                final List<String> nameText = Files.readAllLines(name.toPath());
+                if (!vendorText.isEmpty() && vendorText.get(0).contains("Valve") && !nameText.isEmpty() && nameText.get(0).contains("Jupiter")) {
+                    return true;
+                }
+            } catch (IOException e) {
+                return false;
+            }
+        }
+
+        return false;
+    }
+
 	public void onMinecraftCrash(UnexpectedThrowable throwable) {
 		if(!gameStarted) {
 			running = false;
@@ -391,10 +410,8 @@ public class Minecraft
         this.serverName = serverName;
         this.serverPort = serverPort;
     }
-    
-    public void startGame() throws LWJGLException
-    {
-        ImageIO.setUseCache(false); // Speeds up boot time
+
+    private static void checkLwjglVersion() {
         LOGGER.info("LWJGL version = {}", org.lwjgl.Sys.getVersion());
         if (Integer.parseInt(org.lwjgl.Sys.getVersion().substring(0, 1)) < 3) {
             JOptionPane.showMessageDialog(null,
@@ -416,12 +433,20 @@ public class Minecraft
                                 }
                             });
                         }
-                    }
+                    },
+                    "",
+                    "Please note that MultiMC/Prism Launcher instances from",
+                    "versions prior to 7.3 cannot be manually upgraded to 7.3",
+                    "or later and must be re-downloaded."
                 }
                 , "LWJGL Version Error", JOptionPane.ERROR_MESSAGE);
             System.exit(1);
         }
-
+    }
+    
+    public void startGame() throws LWJGLException
+    {
+        ImageIO.setUseCache(false); // Speeds up boot time
 		mcDataDir = getMinecraftDir();
 
         Holidays.initialize();
@@ -2625,6 +2650,11 @@ public class Minecraft
 
     public static void main(String[] args)
     {
+        checkLwjglVersion();
+        if (isClientASteamDeck()) {
+            System.out.println("Client is a Steam Deck!");
+        }
+
         String playerName = null;
         String sessionId = null;
         String gameDirectory = null;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
index 649630868..17a684050 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
@@ -140,20 +140,17 @@ public class ScreenControllerSetup extends Screen {
             if (mc.controllerInput == null) {
                 index = -1;
             } else {
-                index = Arrays.asList(InputHandler.controllers).indexOf(mc.controllerInput);
+                index = InputHandler.controllers.indexOf(mc.controllerInput);
+            }
+            index++;
+            if (index >= InputHandler.controllers.size()) {
+                index = -1;
             }
-            do {
-                index++;
-                if (index >= InputHandler.controllers.length) {
-                    index = -1;
-                    break;
-                }
-            } while (InputHandler.controllers[index] == null);
             if (index == -1) {
                 mc.controllerInput = null;
                 mc.setInputType(InputType.KEYBOARD);
             } else {
-                mc.controllerInput = InputHandler.controllers[index];
+                mc.controllerInput = InputHandler.controllers.get(index);
                 mc.setInputType(InputType.CONTROLLER);
             }
             updateDisplay();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
index 7e1f912c4..c7b8a463f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
@@ -57,8 +57,7 @@ public class AchievementPages {
         netherPage.addAchievement(Achievements.SWIM_NETHER, 3, 2);
         netherPage.addAchievement(Achievements.HIT_FIREBALL, 3, -2);
         netherPage.addAchievement(Achievements.SLEEP_NETHER, 1, -2);
-        netherPage.addAchievement(Achievements.ENTER_OLDWORLD, 0, -5);
-        netherPage.addAchievement(Achievements.ENTER_WARRENS, 0, 5);
+//        netherPage.addAchievement(Achievements.ENTER_WARRENS, 0, 5);
         netherPage.addAchievement(Achievements.MOST_WANTED, 0, -1);
         netherPage.addAchievement(Achievements.FAST_TRAVEL, 0, 1);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
index d33404c98..99c688928 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
@@ -24,6 +24,7 @@ import net.minecraft.client.render.Font;
 import net.minecraft.core.net.command.*;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.net.packet.PacketRequestCommandManager;
+import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
@@ -284,7 +285,7 @@ public class GuiElementChatSuggestions extends Gui {
         int cursorX = getScaledMouseX(this.mc);
         int cursorY = getScaledMouseY(this.mc);
         if (this.isHoveringOverSuggestions(cursorX, cursorY) && dWheel != 0) {
-            this.scroll(Math.round(Math.signum(dWheel)) * -1);
+            this.scroll(Math.round(Math.signum(dWheel)) * -3);
         }
     }
 
@@ -336,9 +337,7 @@ public class GuiElementChatSuggestions extends Gui {
     }
 
     public void scroll(int amount) {
-        if (this.scroll + amount >= 0 && this.scroll + amount <= this.suggestions.size() - MAX_SUGGESTIONS) {
-            this.scroll += amount;
-        }
+        this.scroll = MathHelper.clamp(scroll + amount, 0, this.suggestions.size() - MAX_SUGGESTIONS);
     }
 
     public void cycleThroughSuggestions() {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
index 9a32dbd57..f69be2941 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainer.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.gui.container;
 
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.menu.MenuContainer;
 import net.minecraft.core.player.inventory.container.Container;
 import org.lwjgl.opengl.GL11;
@@ -22,8 +23,8 @@ public class ScreenContainer extends ScreenContainerAbstract
     @Override
 	protected void drawGuiContainerForegroundLayer()
     {
-        font.drawString(lowerChestInventory.getName(), 8, 6, 0x404040);
-        font.drawString(upperChestInventory.getName(), 8, (ySize - 96) + 2, 0x404040);
+        font.drawString(I18n.getInstance().translateKey(lowerChestInventory.getNameTranslationKey()), 8, 6, 0x404040);
+        font.drawString(I18n.getInstance().translateKey(upperChestInventory.getNameTranslationKey()), 8, (ySize - 96) + 2, 0x404040);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/input/InputHandler.java b/game/client/src/main/java/net/minecraft/client/input/InputHandler.java
index 4dca2a85a..509228c55 100644
--- a/game/client/src/main/java/net/minecraft/client/input/InputHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/input/InputHandler.java
@@ -3,53 +3,92 @@ package net.minecraft.client.input;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.input.glfw.GlfwGamepad;
 import net.minecraft.client.input.glfw.GlfwJoystick;
+import net.minecraft.client.input.sdl.SDLGamepad;
+import org.libsdl.SDL;
+import org.libsdl.SDL_GameController;
+import org.libsdl.SDL_Joystick;
 import org.lwjgl.glfw.GLFW;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.input.controller.ControllerInput;
 import org.slf4j.Logger;
 
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
 public abstract class InputHandler {
 	private static final Logger LOGGER = LogUtils.getLogger();
 	private static Minecraft minecraft;
-	public static ControllerInput[] controllers = new ControllerInput[GLFW.GLFW_JOYSTICK_LAST + 1];
+	public static List<ControllerInput> controllers = new ArrayList<>();
+
+	private static boolean sdl2Initialized = false;
 	
 	public static void init(Minecraft minecraft) throws Exception{
 		InputHandler.minecraft = minecraft;
 
 		try {
-			initLWJGL3(minecraft);
+			initSDL2(minecraft);
 		} catch (Throwable e) {
-			LOGGER.error("Could not initialize LWJGL3.");
+			LOGGER.error("Could not initialize SDL2.");
 			e.printStackTrace();
 		}
 	}
 
 	public static void poll() {
-		for (int i = GLFW.GLFW_JOYSTICK_1; i < GLFW.GLFW_JOYSTICK_LAST; i++) {
-			if (controllers[i] != null) {
-				if (!controllers[i].getController().isPresent()) {
-					disconnected(controllers[i]);
-					controllers[i] = null;
-				} else {
-					controllers[i].getController().poll();
+		if (sdl2Initialized) {
+			SDL.SDL_GameControllerUpdate();
+			try {
+				// Check for any joysticks that are no longer attached
+				for (int i = 0; i < controllers.size(); i++) {
+					ControllerInput input = controllers.get(i);
+					if (!input.getController().isPresent()) {
+						disconnected(controllers.remove(i));
+						i--;
+					}
+				}
+
+				// Check for any new joysticks
+				final int joysticks = SDL.SDL_NumJoysticks();
+				for (int i = 0; i < joysticks; i++) {
+					// Check if not gamepad, and if so, skip
+					if (!SDL.SDL_IsGameController(i)) {
+						continue;
+					}
+					final int instanceId = SDL.SDL_JoystickGetDeviceInstanceID(i);
+					// If controllers does not contain instance ID, add it
+					boolean containsId = false;
+					for (ControllerInput input : controllers) {
+						if (input.getController().getInstanceId() == instanceId) {
+							containsId = true;
+							break;
+						}
+					}
+					if (!containsId) {
+						ControllerInput ci = new ControllerInput(minecraft, new SDLGamepad(i));
+						controllers.add(ci);
+						connected(ci);
+					}
 				}
-			} else {
-				if (GLFW.glfwJoystickPresent(i)) {
-					GlfwGamepad gamepad = new GlfwJoystick(i).intoGamepad();
-					if (gamepad != null) {
-						ControllerInput input = new ControllerInput(minecraft, gamepad);
-						controllers[i] = input;
-						connected(input);
+
+				for (ControllerInput ci : controllers) {
+					if (ci.hasAnyInput()) {
+						minecraft.controllerInput = ci;
+						minecraft.setInputType(InputType.CONTROLLER);
 					}
 				}
+			} catch (Exception ignored) {
+				ignored.printStackTrace();
 			}
+
 		}
 	}
 
 	private static void connected(ControllerInput controller) {
         LOGGER.info("Controller connected: {}", controller.getGUID());
-		minecraft.controllerInput = getController(controller.getGUID());
+		minecraft.controllerInput = controller;
 	}
 
 	private static void disconnected(ControllerInput controller) {
@@ -60,25 +99,16 @@ public abstract class InputHandler {
 		}
 	}
 
-	public static void initLWJGL3(Minecraft minecraft) throws Throwable {
-		int found = 0;
-		for (int i = GLFW.GLFW_JOYSTICK_1; i < GLFW.GLFW_JOYSTICK_LAST; i++) {
-			if (GLFW.glfwJoystickPresent(i)) {
-				GlfwGamepad gamepad = new GlfwJoystick(i).intoGamepad();
-				if (gamepad != null) {
-					ControllerInput input = new ControllerInput(minecraft, gamepad);
-					controllers[i] = input;
-					found++;
-				}
-			}
+	public static void initSDL2(Minecraft minecraft) throws Throwable {
+		SDL.SDL_SetHint("SDL_JOYSTICK_RAWINPUT", "0");
+		final int result = SDL.SDL_Init(SDL.SDL_INIT_JOYSTICK | SDL.SDL_INIT_GAMECONTROLLER);
+		if (result < 0) {
+			throw new IOException("Could not initialize SDL2!");
 		}
-//		int[] vids = { 0x0079, 0x0079, 0x054c, 0x0079, 0x03F0, 0x057e, 0x28de, 0x28de };
-//		int[] pids = { 0x181a, 0x181b, 0x0ce6, 0x18d4, 0x0495, 0x2008, 0x1101, 0x11ff };
-//		String[] names = { "Fake PS3", "Fake PS4", "Fake PS5", "Fake X360", "Fake XONE", "Fake Switch", "Fake Steam", "Fake Steam Deck" };
-//		for (int i = 0; i < vids.length; i++) {
-//			controllers[GLFW.GLFW_JOYSTICK_1 + i] = new ControllerInput(minecraft, new FakeGamepad(GLFW.GLFW_JOYSTICK_1 + i, names[i], vids[i], pids[i]));
-//		}
-    LOGGER.info("{} controllers found!", found);
+
+		sdl2Initialized = true;
+
+		poll();
 	}
 
 	public static ControllerInput getController(String guid) {
diff --git a/game/client/src/main/java/net/minecraft/client/input/controller/ControllerInput.java b/game/client/src/main/java/net/minecraft/client/input/controller/ControllerInput.java
index 3a2d18b90..49af4af60 100644
--- a/game/client/src/main/java/net/minecraft/client/input/controller/ControllerInput.java
+++ b/game/client/src/main/java/net/minecraft/client/input/controller/ControllerInput.java
@@ -4,15 +4,17 @@ import com.b100.utils.ReflectUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.container.ScreenContainerAbstract;
 import net.minecraft.client.input.glfw.GlfwGamepad;
+import net.minecraft.client.input.sdl.SDLGamepad;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.util.helper.Time;
+import org.libsdl.SDL;
 import org.lwjgl.glfw.GLFW;
 
 public class ControllerInput {
 
     public final Minecraft minecraft;
 
-    private final GlfwGamepad controller;
+    private final SDLGamepad controller;
 
     public Joystick joyLeft;
     public Joystick joyRight;
@@ -45,7 +47,7 @@ public class ControllerInput {
 
     private boolean disconnected = false;
 
-    public ControllerInput(Minecraft minecraft, GlfwGamepad controller) {
+    public ControllerInput(Minecraft minecraft, SDLGamepad controller) {
         this.minecraft = minecraft;
         this.controller = controller;
 
@@ -66,47 +68,47 @@ public class ControllerInput {
         IButtonListener defaultButtonListener = controller::isButtonPressed;
         IJoystickListener defaultJoystickListener = controller::getAxisValue;
 
-        joyLeft = new Joystick(translateAxis(type, GLFW.GLFW_GAMEPAD_AXIS_LEFT_X), GLFW.GLFW_GAMEPAD_AXIS_LEFT_X, GLFW.GLFW_GAMEPAD_AXIS_LEFT_Y, defaultJoystickListener, new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_LEFT_THUMB), GLFW.GLFW_GAMEPAD_BUTTON_LEFT_THUMB, defaultButtonListener), minecraft.gameSettings.controllerDeadzoneLeft);
-        joyRight = new Joystick(translateAxis(type, GLFW.GLFW_GAMEPAD_AXIS_RIGHT_X), GLFW.GLFW_GAMEPAD_AXIS_RIGHT_X, GLFW.GLFW_GAMEPAD_AXIS_RIGHT_Y, defaultJoystickListener, new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_THUMB), GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_THUMB, defaultButtonListener), minecraft.gameSettings.controllerDeadzoneRight);
+        joyLeft = new Joystick(translateAxis(type, SDL.SDL_CONTROLLER_AXIS_LEFTX), SDL.SDL_CONTROLLER_AXIS_LEFTX, SDL.SDL_CONTROLLER_AXIS_LEFTY, defaultJoystickListener, new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_LEFTSTICK), SDL.SDL_CONTROLLER_BUTTON_LEFTSTICK, defaultButtonListener), minecraft.gameSettings.controllerDeadzoneLeft);
+        joyRight = new Joystick(translateAxis(type, SDL.SDL_CONTROLLER_AXIS_RIGHTX), SDL.SDL_CONTROLLER_AXIS_RIGHTX, SDL.SDL_CONTROLLER_AXIS_RIGHTY, defaultJoystickListener, new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_RIGHTSTICK), SDL.SDL_CONTROLLER_BUTTON_RIGHTSTICK, defaultButtonListener), minecraft.gameSettings.controllerDeadzoneRight);
 
-        buttonBack = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_BACK), GLFW.GLFW_GAMEPAD_BUTTON_BACK, defaultButtonListener);
-        buttonStart = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_START), GLFW.GLFW_GAMEPAD_BUTTON_START, defaultButtonListener);
+        buttonBack = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_BACK), SDL.SDL_CONTROLLER_BUTTON_BACK, defaultButtonListener);
+        buttonStart = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_START), SDL.SDL_CONTROLLER_BUTTON_START, defaultButtonListener);
 
         if (minecraft.gameSettings.controllerSwapAB.value) {
-            buttonA = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_A), GLFW.GLFW_GAMEPAD_BUTTON_B, defaultButtonListener);
-            buttonB = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_B), GLFW.GLFW_GAMEPAD_BUTTON_A, defaultButtonListener);
+            buttonA = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_A), SDL.SDL_CONTROLLER_BUTTON_B, defaultButtonListener);
+            buttonB = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_B), SDL.SDL_CONTROLLER_BUTTON_A, defaultButtonListener);
         } else {
-            buttonA = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_A), GLFW.GLFW_GAMEPAD_BUTTON_A, defaultButtonListener);
-            buttonB = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_B), GLFW.GLFW_GAMEPAD_BUTTON_B, defaultButtonListener);
+            buttonA = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_A), SDL.SDL_CONTROLLER_BUTTON_A, defaultButtonListener);
+            buttonB = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_B), SDL.SDL_CONTROLLER_BUTTON_B, defaultButtonListener);
         }
 
         if (minecraft.gameSettings.controllerSwapXY.value) {
-            buttonX = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_X), GLFW.GLFW_GAMEPAD_BUTTON_Y, defaultButtonListener);
-            buttonY = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_Y), GLFW.GLFW_GAMEPAD_BUTTON_X, defaultButtonListener);
+            buttonX = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_X), SDL.SDL_CONTROLLER_BUTTON_Y, defaultButtonListener);
+            buttonY = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_Y), SDL.SDL_CONTROLLER_BUTTON_X, defaultButtonListener);
         } else {
-            buttonX = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_X), GLFW.GLFW_GAMEPAD_BUTTON_X, defaultButtonListener);
-            buttonY = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_Y), GLFW.GLFW_GAMEPAD_BUTTON_Y, defaultButtonListener);
+            buttonX = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_X), SDL.SDL_CONTROLLER_BUTTON_X, defaultButtonListener);
+            buttonY = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_Y), SDL.SDL_CONTROLLER_BUTTON_Y, defaultButtonListener);
         }
 
         if (minecraft.gameSettings.controllerSwapShoulderButtons.value) {
-            buttonLeftShoulder = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_LEFT_BUMPER), GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_BUMPER, defaultButtonListener);
-            buttonRightShoulder = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_BUMPER), GLFW.GLFW_GAMEPAD_BUTTON_LEFT_BUMPER, defaultButtonListener);
+            buttonLeftShoulder = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_LEFTSHOULDER), SDL.SDL_CONTROLLER_BUTTON_RIGHTSHOULDER, defaultButtonListener);
+            buttonRightShoulder = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_RIGHTSHOULDER), SDL.SDL_CONTROLLER_BUTTON_LEFTSHOULDER, defaultButtonListener);
 
-            buttonLeftTrigger = new Button(translateAxis(type, GLFW.GLFW_GAMEPAD_AXIS_LEFT_TRIGGER), GLFW.GLFW_GAMEPAD_AXIS_RIGHT_TRIGGER, (axis) -> this.controller.getAxisValue(axis) > 0.5f);
-            buttonRightTrigger = new Button(translateAxis(type, GLFW.GLFW_GAMEPAD_AXIS_RIGHT_TRIGGER), GLFW.GLFW_GAMEPAD_AXIS_LEFT_TRIGGER, (axis) -> this.controller.getAxisValue(axis) > 0.5f);
+            buttonLeftTrigger = new Button(translateAxis(type, SDL.SDL_CONTROLLER_AXIS_TRIGGERLEFT), SDL.SDL_CONTROLLER_AXIS_TRIGGERRIGHT, (axis) -> this.controller.getAxisValue(axis) > 0.5f);
+            buttonRightTrigger = new Button(translateAxis(type, SDL.SDL_CONTROLLER_AXIS_TRIGGERRIGHT), SDL.SDL_CONTROLLER_AXIS_TRIGGERLEFT, (axis) -> this.controller.getAxisValue(axis) > 0.5f);
         } else {
-            buttonLeftShoulder = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_LEFT_BUMPER), GLFW.GLFW_GAMEPAD_BUTTON_LEFT_BUMPER, defaultButtonListener);
-            buttonRightShoulder = new Button(translateBtn(type, GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_BUMPER), GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_BUMPER, defaultButtonListener);
+            buttonLeftShoulder = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_LEFTSHOULDER), SDL.SDL_CONTROLLER_BUTTON_LEFTSHOULDER, defaultButtonListener);
+            buttonRightShoulder = new Button(translateBtn(type, SDL.SDL_CONTROLLER_BUTTON_RIGHTSHOULDER), SDL.SDL_CONTROLLER_BUTTON_RIGHTSHOULDER, defaultButtonListener);
 
-            buttonLeftTrigger = new Button(translateAxis(type, GLFW.GLFW_GAMEPAD_AXIS_LEFT_TRIGGER), GLFW.GLFW_GAMEPAD_AXIS_LEFT_TRIGGER, (axis) -> this.controller.getAxisValue(axis) > 0.5f);
-            buttonRightTrigger = new Button(translateAxis(type, GLFW.GLFW_GAMEPAD_AXIS_RIGHT_TRIGGER), GLFW.GLFW_GAMEPAD_AXIS_RIGHT_TRIGGER, (axis) -> this.controller.getAxisValue(axis) > 0.5f);
+            buttonLeftTrigger = new Button(translateAxis(type, SDL.SDL_CONTROLLER_AXIS_TRIGGERLEFT), SDL.SDL_CONTROLLER_AXIS_TRIGGERLEFT, (axis) -> this.controller.getAxisValue(axis) > 0.5f);
+            buttonRightTrigger = new Button(translateAxis(type, SDL.SDL_CONTROLLER_AXIS_TRIGGERRIGHT), SDL.SDL_CONTROLLER_AXIS_TRIGGERRIGHT, (axis) -> this.controller.getAxisValue(axis) > 0.5f);
         }
 
         digitalPad = new DigitalPad(
-            new Button("Digital Up", GLFW.GLFW_GAMEPAD_BUTTON_DPAD_UP, defaultButtonListener),
-            new Button("Digital Left", GLFW.GLFW_GAMEPAD_BUTTON_DPAD_LEFT, defaultButtonListener),
-            new Button("Digital Down", GLFW.GLFW_GAMEPAD_BUTTON_DPAD_DOWN, defaultButtonListener),
-            new Button("Digital Right", GLFW.GLFW_GAMEPAD_BUTTON_DPAD_RIGHT, defaultButtonListener)
+            new Button("Digital Up", SDL.SDL_CONTROLLER_BUTTON_DPAD_UP, defaultButtonListener),
+            new Button("Digital Left", SDL.SDL_CONTROLLER_BUTTON_DPAD_LEFT, defaultButtonListener),
+            new Button("Digital Down", SDL.SDL_CONTROLLER_BUTTON_DPAD_DOWN, defaultButtonListener),
+            new Button("Digital Right", SDL.SDL_CONTROLLER_BUTTON_DPAD_RIGHT, defaultButtonListener)
         );
 
         buttons = ReflectUtils.getAllObjects(ControllerInput.class, Button.class, this);
@@ -126,7 +128,11 @@ public class ControllerInput {
         cursorY = Math.min(cursorY, minecraft.resolution.getScaledHeightScreenCoords());
     }
 
-    public GlfwGamepad getController() {
+    public boolean hasAnyInput() {
+        return controller.hasAnyInput();
+    }
+
+    public SDLGamepad getController() {
         return controller;
     }
 
@@ -187,13 +193,13 @@ public class ControllerInput {
 
     private String translateAxis(ControllerType controllerType, int axis) {
         switch (axis) {
-            case GLFW.GLFW_GAMEPAD_AXIS_LEFT_X:
-            case GLFW.GLFW_GAMEPAD_AXIS_LEFT_Y:
+            case SDL.SDL_CONTROLLER_AXIS_LEFTX:
+            case SDL.SDL_CONTROLLER_AXIS_LEFTY:
                 return "Analog Left";
-            case GLFW.GLFW_GAMEPAD_AXIS_RIGHT_X:
-            case GLFW.GLFW_GAMEPAD_AXIS_RIGHT_Y:
+            case SDL.SDL_CONTROLLER_AXIS_RIGHTX:
+            case SDL.SDL_CONTROLLER_AXIS_RIGHTY:
                 return "Analog Right";
-            case GLFW.GLFW_GAMEPAD_AXIS_LEFT_TRIGGER:
+            case SDL.SDL_CONTROLLER_AXIS_TRIGGERLEFT:
                 switch (controllerType) {
                     case PS3:
                     case PS4:
@@ -204,7 +210,7 @@ public class ControllerInput {
                     default:
                         return "LT";
                 }
-            case GLFW.GLFW_GAMEPAD_AXIS_RIGHT_TRIGGER:
+            case SDL.SDL_CONTROLLER_AXIS_TRIGGERRIGHT:
                 switch (controllerType) {
                     case PS3:
                     case PS4:
@@ -222,7 +228,7 @@ public class ControllerInput {
 
     private String translateBtn(ControllerType controllerType, int button) {
         switch (button) {
-            case GLFW.GLFW_GAMEPAD_BUTTON_A:
+            case SDL.SDL_CONTROLLER_BUTTON_A:
                 switch (controllerType) {
                     case PS3:
                     case PS4:
@@ -233,7 +239,7 @@ public class ControllerInput {
                     default:
                         return "A";
                 }
-            case GLFW.GLFW_GAMEPAD_BUTTON_B:
+            case SDL.SDL_CONTROLLER_BUTTON_B:
                 switch (controllerType) {
                     case PS3:
                     case PS4:
@@ -244,7 +250,7 @@ public class ControllerInput {
                     default:
                         return "B";
                 }
-            case GLFW.GLFW_GAMEPAD_BUTTON_X:
+            case SDL.SDL_CONTROLLER_BUTTON_X:
                 switch (controllerType) {
                     case PS3:
                     case PS4:
@@ -255,7 +261,7 @@ public class ControllerInput {
                     default:
                         return "X";
                 }
-            case GLFW.GLFW_GAMEPAD_BUTTON_Y:
+            case SDL.SDL_CONTROLLER_BUTTON_Y:
                 switch (controllerType) {
                     case PS3:
                     case PS4:
@@ -266,7 +272,7 @@ public class ControllerInput {
                     default:
                         return "Y";
                 }
-            case GLFW.GLFW_GAMEPAD_BUTTON_BACK:
+            case SDL.SDL_CONTROLLER_BUTTON_BACK:
                 switch (controllerType) {
                     case XBOX_ONE:
                         return "View";
@@ -280,7 +286,7 @@ public class ControllerInput {
                     default:
                         return "Back";
                 }
-            case GLFW.GLFW_GAMEPAD_BUTTON_START:
+            case SDL.SDL_CONTROLLER_BUTTON_START:
                 switch (controllerType) {
                     case XBOX_ONE:
                         return "Menu";
@@ -292,7 +298,7 @@ public class ControllerInput {
                     default:
                         return "Start";
                 }
-            case GLFW.GLFW_GAMEPAD_BUTTON_LEFT_BUMPER:
+            case SDL.SDL_CONTROLLER_BUTTON_LEFTSHOULDER:
                 switch (controllerType) {
                     case PS3:
                     case PS4:
@@ -303,7 +309,7 @@ public class ControllerInput {
                     default:
                         return "LB";
                 }
-            case GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_BUMPER:
+            case SDL.SDL_CONTROLLER_BUTTON_RIGHTSHOULDER:
                 switch (controllerType) {
                     case PS3:
                     case PS4:
@@ -314,17 +320,17 @@ public class ControllerInput {
                     default:
                         return "RB";
                 }
-            case GLFW.GLFW_GAMEPAD_BUTTON_LEFT_THUMB:
+            case SDL.SDL_CONTROLLER_BUTTON_LEFTSTICK:
                 return "Left Stick";
-            case GLFW.GLFW_GAMEPAD_BUTTON_RIGHT_THUMB:
+            case SDL.SDL_CONTROLLER_BUTTON_RIGHTSTICK:
                 return "Right Stick";
-            case GLFW.GLFW_GAMEPAD_BUTTON_DPAD_UP:
+            case SDL.SDL_CONTROLLER_BUTTON_DPAD_UP:
                 return "Digital Up";
-            case GLFW.GLFW_GAMEPAD_BUTTON_DPAD_DOWN:
+            case SDL.SDL_CONTROLLER_BUTTON_DPAD_DOWN:
                 return "Digital Down";
-            case GLFW.GLFW_GAMEPAD_BUTTON_DPAD_LEFT:
+            case SDL.SDL_CONTROLLER_BUTTON_DPAD_LEFT:
                 return "Digital Left";
-            case GLFW.GLFW_GAMEPAD_BUTTON_DPAD_RIGHT:
+            case SDL.SDL_CONTROLLER_BUTTON_DPAD_RIGHT:
                 return "Digital Right";
             default:
                 return "Button " + button;
diff --git a/game/client/src/main/java/net/minecraft/client/input/controller/ControllerType.java b/game/client/src/main/java/net/minecraft/client/input/controller/ControllerType.java
index b59abd297..d4082a0c5 100644
--- a/game/client/src/main/java/net/minecraft/client/input/controller/ControllerType.java
+++ b/game/client/src/main/java/net/minecraft/client/input/controller/ControllerType.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.input.controller;
 
-import net.minecraft.client.input.glfw.GlfwGamepad;
+import net.minecraft.client.input.sdl.SDLGamepad;
 
 public enum ControllerType {
     UNKNOWN(Layout.XBOX, "xbox_360", "UNKNOWN"),
@@ -23,7 +23,7 @@ public enum ControllerType {
         this.printableName = printableName;
     }
 
-    public static ControllerType fromController(GlfwGamepad controller) {
+    public static ControllerType fromController(SDLGamepad controller) {
         int vid = controller.getVendorId();
         int pid = controller.getDeviceId();
         return ControllerTypeDatabase.getControllerType(vid, pid);
